#ifndef HITSET__H
#define HITSET__H
#include "DDTBaseDataProducts/CompareDAQHit.h"
#include "DDTBaseDataProducts/DAQHit.h"
#include<set>

namespace novaddt{
    class HitSet;
};

//utility class HitSet, for hit set substraction and addition
class novaddt::HitSet: public std::set<novaddt::DAQHit, novaddt::CompareDAQHit<TDC>>{
    using base_set=std::set<novaddt::DAQHit, novaddt::CompareDAQHit<TDC>>;
    public:
        HitSet():base_set(){};

      template<class AnyCollection>
        HitSet(const AnyCollection& v):base_set(v.begin(),v.end()){};

      template<class AnyCollection>
        void add(const AnyCollection& v){
            insert(v.begin(),v.end()); 
        }

      template<class AnyCollection>
        void substract(const AnyCollection& v){
            for(const auto& hit: v){
                auto it=find(hit);
                if(it!=end())erase(it);
            }
        }
};
#endif
